/*
	
	GRIM DAWN
	
	For more information, visit us at http://www.grimdawn.com
		
*/
-- everybodydies.lua
-- A set of functions that will allow to make every NPC hostile
-- Created By: PrincessLuna
-- Created On: 05/17/2016
-- SteamID: STEAM_0:0:46032300

gd.everybodydies = {}
gd.everybodydies.entityOnDestroy = ClearObjectUserdata
local g_objectIDs = {}
local g_objectsTotal = 0
local StateTableObjects = {}
-- Ordered table generation function
local function generateStateTable(dbrPath, playerToken, objectsTotal)
	local dbrPathSub = string.sub(dbrPath, 0, -5)
	local npcState = { Friendly = 0, Hostile = 1 }
	StateTableObjects[objectsTotal] = orderedTable()
	StateTableObjects[objectsTotal][playerToken] = { state = npcState.Hostile, dbr = dbrPathSub.."_enemy.dbr" }
	StateTableObjects[objectsTotal][""] 			= { state = npcState.Friendly,  dbr = dbrPathSub.."_friend.dbr" }
	return StateTableObjects[objectsTotal]
end

-- Assigns object swap to the objectId
function gd.everybodydies.SetStateObjects(objectId, StateName)
	if Server then
		local userdata = {}
		TokenStateBasedObjectSwap(objectId, userdata, StateName)
		Shared.setUserdata(objectId, userdata)
	end
end

function giveTokenNPCKilled(objectId)
	local player = Game.GetLocalPlayer()
	local obj = Character.Get(objectId)
	local dbrPath = obj:GetName()
	if (dbrPath == "records/creatures/npcs/flavornpcs/devilscrossing/gateguard01_enemy.dbr") then
		player:GiveToken("DC_PRISON_GUARD_KILLED")
		gd.quests.devilsCrossing.prisonGateEntry()
	end
end

function GiveDebugInfo()
	local leng = nil
	UI.Notify("g_objectsTotal = "..tostring(g_objectsTotal))
	leng = table.getn(g_objectIDs)
	UI.Notify("g_objectIDs length = "..tostring(leng))
	leng = table.getn(StateTableObjects)
	UI.Notify("StateTableObjects length = "..tostring(leng))
end

-- Gets path of the entity
-- To make script work, folder must contain the following .dbrs:
-- Target.dbr (a script entity that replaces NPC)
-- Target_friend.dbr
-- Target_enemy.dbr
-- You may use other names instead of "Target", but the .dbrs ending by "_friend" and "_enemy" must be in the same folder.
-- playerToken - desired token to trigger the entity swap
-- FOR STATIC NPCs Only!
function gd.everybodydies.OnAddToWorldDevilsCrossing(objectId)
--DEBUG
	local player = Game.GetLocalPlayer()
	player:RemoveToken("DEVILSCROSSING_ATTACKED")
	
	--player:RemoveToken("DC_BOURBON_OFFICE")
	--player:RemoveToken("INVENTOR_SERVICE")
	player:RemoveToken("INVENTOR_ATTACKED")
	player:RemoveToken("DC_TRAITOR_HOSTILE")
	
	--player:GiveToken("INVENTOR_SERVICE")
	--player:GiveToken("DC_BOURBON_OFFICE")
	--player:GiveToken("DC_TRAITOR_HOSTILE")
--DEBUG
	local obj = Object.Get(objectId)
	local dbrPath = obj:GetName()
	local playerToken = "DEVILSCROSSING_ATTACKED"	
	g_objectsTotal=g_objectsTotal+1
	g_objectIDs[g_objectsTotal] = objectId
	gd.everybodydies.SetStateObjects(objectId, generateStateTable(dbrPath, playerToken, g_objectsTotal))
end

function gd.everybodydies.Update()
	--GiveDebugInfo()
	local player = Game.GetLocalPlayer()
		local i = 1
		while (i <= g_objectsTotal) do
			UpdateObjectSwap(g_objectIDs[i], StateTableObjects[i])
			i = i+1		
		end
	gd.quests.devilsCrossing.johnBourbon.Update()
	gd.quests.devilsCrossingNPCSpiritGuide.Update()
	gd.quests.devilsCrossingNPCCook.Update()
	gd.quests.devilsCrossingQuestLostJournal.DireniUpdate()
	gd.quests.devilsCrossingTownAttacks.DCGuardIdle01Update()
	gd.quests.devilsCrossingNPCInventor.Update()
	--gd.everybodydies.SetLevel(17)
end

function gd.everybodydies.SetLevel(amount)
UI.Notify("starting giving levels")
	local player = Game.GetLocalPlayer()
	local i = Game.GetAveragePlayerLevel()
	UI.Notify("while...")
	while (i<=amount) do
		player:GiveLevels(1)
		i = Game.GetAveragePlayerLevel()
	end
	player:AdjustMoney(1000000)
	player:GiveItem("records/items/gearweapons/melee2h/c009_sword2h.dbr", 1, false)
	player:GiveItem("records/items/geartorso/c024_torso.dbr", 1, false)
	player:GiveItem("records/items/gearrelic/d014_relic.dbr", 1, false)
	player:GiveItem("records/items/gearlegs/d009_legs.dbr", 1, false)
	player:GiveItem("records/items/gearshoulders/d020_shoulder.dbr", 1, false)
	player:GiveItem("records/items/gearhands/d008_hands.dbr", 1, false)
	player:GiveItem("records/items/gearaccessories/medals/d0211_medal.dbr", 1, false)
	player:GiveItem("records/items/gearaccessories/necklaces/d020_necklace.dbr", 1, false)
	player:GiveItem("records/items/gearaccessories/rings/c051_ring.dbr", 1, false)
	player:GiveItem("records/items/gearaccessories/rings/d014_ring.dbr", 1, false)
	
end